%ifarch %{ocaml_native_compiler}
%global native_compiler 1
%else
%global native_compiler 0
%endif

Summary:       Tcl/Tk interface for OCaml
Name:          ocaml-labltk
Version:       8.06.12
Release:       6%{?dist}
License:       LGPLv2+ with exceptions

URL:           https://github.com/garrigue/labltk
Source0:       https://github.com/garrigue/labltk/archive/%{version}/labltk-%{version}.tar.gz

Patch3000:        labltk-8.06.11-enable-debugging.patch
Patch3001:        labltk-8.06.12-use-fpic-configure.patch

BuildRequires: make ocaml tcl-devel, tk-devel, ocaml-ocamldoc


%description
labltk or mlTk is a library for interfacing OCaml with the scripting
language Tcl/Tk (all versions since 8.0.3, but no betas).


%package devel
Summary:       Tcl/Tk interface for OCaml

Requires:      %{name} = %{version}-%{release}


%description devel
This package contains the development files.


%prep
%autosetup -p1 -n labltk-%{version}


find -type f | xargs sed -i -e 's/-warn-error/-w/g'

mv browser browser.old
mkdir browser
echo -e 'all:\ninstall:\n' > browser/Makefile


%build
./configure -verbose
unset MAKEFLAGS

%if !%{native_compiler}
make byte
%else
make all opt \
     SHAREDCCCOMPOPTS="%{optflags} -fPIC" \
     TK_LINK="%{build_ldflags} $(pkg-config --libs tk)"
%endif


%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}/ocaml/labltk
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
make install \
    BINDIR=%{buildroot}%{_bindir} \
    INSTALLDIR=%{buildroot}%{_libdir}/ocaml/labltk \
    STUBLIBDIR=%{buildroot}%{_libdir}/ocaml/stublibs \
    RANLIB=:
%if %{native_compiler}
install -m 0644 camltk/*.o %{buildroot}%{_libdir}/ocaml/labltk
%endif


%files
%doc Changes README.mlTk
%dir %{_libdir}/ocaml/labltk
%{_libdir}/ocaml/labltk/*.cmi
%{_libdir}/ocaml/labltk/*.cma
%{_libdir}/ocaml/labltk/*.cmo
%{_libdir}/ocaml/stublibs/dlllabltk.so


%files devel
%doc README.mlTk examples_camltk examples_labltk
%{_bindir}/labltk
%{_libdir}/ocaml/labltk/labltktop
%{_libdir}/ocaml/labltk/pp
%{_libdir}/ocaml/labltk/tkcompiler
%{_libdir}/ocaml/labltk/*.a
%if %{native_compiler}
%{_libdir}/ocaml/labltk/*.cmxa
%{_libdir}/ocaml/labltk/*.cmx
%{_libdir}/ocaml/labltk/*.o
%endif
%{_libdir}/ocaml/labltk/*.mli


%changelog
* Wed Jun 19 2024 cunshunxia <cunshunxia@tencent.com> - 8.06.12-6
- [Type] other
- [DESC] Rebuilt for ocaml, add ocaml-ocamldoc buildrequires.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.06.12-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 8.06.12-4
- Rebuilt for tcl 8.6.13

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.06.12-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.06.12-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 20 2023 cunshunxia <cunshunxia@tencent.com> - 8.06.12-1
- initial build
